# This specfile was generated automatically.
# If something needs to be changed - please contact Anders Waananen <waananen@nbi.dk>
# to make sure the changes gets added upstream.

%define _prefix /opt/globus

Summary: Globus - Mds Common Setup
Name: globus_mds_common_setup
Version: 2.5
Release: 0.3
Group: Globus/Mds_common
License: Globus Toolkit Public License (GTPL)
Url: http://www.globus.org/
Source: %{name}-%{version}.tar.gz
Prefix: %{_prefix}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Patch: globus_mds_common_setup.patch
BuildRequires: globus_core >= 4
BuildRequires: globus_core-devel >= 4
BuildRequires: gpt
Requires: globus_common_setup >= 2

%ifarch x86_64 alpha
%define flavor gcc64pthr
%else
%define flavor gcc32pthr
%endif

%description
Mds Common Setup
%prep
%setup -q
%patch -p0
cp -p configure configure.orig
cat configure.orig | \
    sed -e 's!^prefix=.$(GLOBUS_LOCATION).*!prefix=%{_prefix}!' \
        -e 's!^exec_prefix=.$(GLOBUS_LOCATION).*!exec_prefix=%{_prefix}!' \
         > configure
rm -f configure.orig

for i in configure*
do
  cp -p $i orig.$i
  cat orig.$i | \
      sed -e 's!^ac_default_prefix=/usr/local.*!ac_default_prefix=%{_prefix}!' \
          > $i
  rm -f orig.$i
done


for i in `find . -name Makefile.in`
do
  cp -p $i $i.orig
  sed -e 's!\(^[a-zA-Z_]*\) = \$[({]GLOBUS_LOCATION[)}]!\1 = $(prefix)!' < $i.orig > $i
done

#
# Don't hardcode any paths into the libraries
#
suffix=.hardcodebackup
for i in `find . \( -name configure -o  -name \*.m4 \) -type f` ; do
  if grep -q hardcode_into_libs=yes $i ; then
    echo "Fixing hardcode in $i"
    cp -p $i $i$suffix
    cat $i$suffix |sed 's/hardcode_into_libs=yes/hardcode_into_libs=no/g' > $i
    rm -f $i$suffix
  fi
done

##
## BUILD
##

%build
flavor=%{flavor}
rm -rf $RPM_BUILD_ROOT

# Create build directory so it's not deleted after the build
mkdir BUILD


#
# The actual build
#

$GPT_LOCATION/sbin/gpt-build -verbose --srcdir=`pwd` ${flavor}

#
# Create RPM filelists
#

# Non-dev files
(
 for j in {pkgdata/,}${flavor}_{pgm,rtl}.filelist {pkgdata/,}noflavor_{data,doc,pgm}.filelist
 do
   test -r $j && cat $j
 done
) | sed -e 's,globus_packages,gpt/packages,' | sort | uniq > package.filelist

# Dev files
(
 for j in {pkgdata/,}${flavor}_dev.filelist {pkgdata/,}noflavor_dev.filelist
 do
   test -r $j && cat $j
 done
) | sed -e 's,globus_packages,gpt/packages,' | sort | uniq > package-devel.filelist

##
## Install
##

%install
flavor=%{flavor}
mkdir -p $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages
( cd  $RPM_BUILD_ROOT%{_prefix}/etc ; ln -s gpt/packages globus_packages)
make install DESTDIR=$RPM_BUILD_ROOT

#
# Fix .la files:
# - Change libs from %{_prefix}/libmylib.la to -L%{_prefix} -lmylib
# - Hardwire prefix to %{_prefix} instead of GLOBUS_LOCATION used at build time
#

echo "Fixing paths in .la files"
for i in $RPM_BUILD_ROOT%{_prefix}/lib*/lib*.la
do
  if test -r "$i"
  then
  cp -p $i $i.oldcopy
  sed -e "s!%{_prefix}/lib/lib\([a-zA-Z0-9._]*\).la!-l\1!g" \
      -e "s!$GLOBUS_LOCATION!%{_prefix}!g" < $i.oldcopy     \
       > $i
  rm -f $i.oldcopy
  fi
done

#
# Well the above might be good in some realities - but delete the stuff and
# remove from filelists.
# Note: Only remove .la files in /opt/globus/lib since /opt/globus/libexec/openldap
#       has required .la files for loadable modules
#
test -d $RPM_BUILD_ROOT%{_prefix}/lib &&
find $RPM_BUILD_ROOT%{_prefix}/lib -name 'lib*.la' -exec rm -rfv '{}' \;
for i in package*.filelist $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/*filelist
do
  cp -p $i $i.orig
  grep -v 'lib/.*\.la$' < $i.orig > $i || :
  rm -f $i.orig
done

#
# Fix GPT filelists:
# - Remove DESTDIR/%{_prefix}
#

for i in $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/*filelist
do
  cp -p $i $i.orig
  sed "s!^$RPM_BUILD_ROOT%{_prefix}!!" < $i.orig > $i
  rm -f $i.orig
done

#
# Remove metadata files for empty packages or pgm_static packages
# (an empty package is a package with <= 2 files)
#

for i in {pkgdata,.}/noflavor*.filelist {pkgdata,.}/${flavor}*.filelist
do
  if test -r "$i"; then
  nf=`wc -l < $i|tr -d ' '` 
  if test $nf -le 2 -o `basename $i` = ${flavor}_pgm_static.filelist \
                     -o `basename $i` = noflavor_pgm_static.filelist
  then
    pn=`basename $i .filelist`
    echo Removing metadata files in filelist for package $pn
    for p in package package-devel
    do
      mv $p.filelist $p.filelist.old
      cat $p.filelist.old | egrep -v "$pn.(filelist|gpt)$" > $p.filelist || :
    done
    echo Removing files - if any
    rm -fv $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/$pn.filelist
    rm -fv $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/pkg_data_$pn.gpt
  fi
  fi
done

#
# Remove metadata files which have been installed, but have no associated filelists
#

for i in $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/pkg_data_*gpt
do
  p=`basename $i .gpt |sed 's/^pkg_data_//'`
  test -r $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/$p.filelist || rm -f $i
done

#
# Remove unpackaged files
#

rm -f $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/*.format

echo "%{_prefix}/etc/globus_packages" >> package.filelist
#
# Merge file lists since we do not make a separate devel package (yet)
#

cat package-devel.filelist >> package.filelist

%post
# Try to make sure GPT_LOCATION is set
if test "x$GPT_LOCATION" = "x"
then
  if test -f /etc/profile.d/gpt.sh
  then
    source /etc/profile.d/gpt.sh
  fi
fi
export GLOBUS_LOCATION=$RPM_INSTALL_PREFIX
cd $RPM_INSTALL_PREFIX/setup/globus/
./setup-globus-mds-common

%clean
rm -rf $RPM_BUILD_ROOT

%files -f package.filelist
%defattr(-,root,root,-)

%changelog
* Mon Mar 27 2006 Anders Waananen <waananen@nbi.dk> - 2.5-0.3
- Autogenerated
